/* (c) by Thomas Oltzen
 * Created on 15.07.2007
 *
 */
package de.oltzen.awt;

import java.awt.*;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;

@SuppressWarnings("serial")
public class ArrowComponent extends Component{
    private int theXPos;

    private int theYPos;

    public Image img;

    private ImageIcon imgicon;

    public ArrowComponent() {
        setSize(200, 200);
        imgicon = new ImageIcon("/DSCF0516.JPG");
        System.out.println(imgicon);
        System.out.println(imgicon.getIconHeight());
        img = imgicon.getImage();
    }

    public void setArrowPosition(int x, int y) {
        setLocation(x - 100, y - 100);
        // System.out.println("insets=" + getParent().getInsets());
        // System.out.println("getParent=" + getParent());
        theXPos = x;
        theYPos = y;
    }

    public void paint(Graphics g) {
        //imgicon.paintIcon(getParent(), g, -100, -100);
        Container parent = getParent();
        g.setColor(Color.RED);
        BasicStroke bs = new BasicStroke(3);
        Graphics2D g2d = (Graphics2D) g;

        g2d.setStroke(bs);

        if (parent.getWidth() / 2 > theXPos) {
            if (parent.getHeight() / 2 > theYPos) {
                g.drawLine(100, 100, 200, 200);
                g.drawLine(100, 100, 100, 130);
                g.drawLine(100, 100, 130, 100);
            } else {
                g.drawLine(100, 100, 200, 0);
                g.drawLine(100, 100, 100, 70);
                g.drawLine(100, 100, 130, 100);
            }
        } else {
            if (parent.getHeight() / 2 > theYPos) {
                g.drawLine(100, 100, 0, 200);
                g.drawLine(100, 100, 100, 130);
                g.drawLine(100, 100, 70, 100);
            } else {
                g.drawLine(100, 100, 0, 0);
                g.drawLine(100, 100, 100, 70);
                g.drawLine(100, 100, 70, 100);
            }
        }

        // if (parent.getWidth() / 2 > theXPos) {
        // if (parent.getHeight() / 2 > theYPos) {
        // g.drawLine(theXPos, theYPos, theXPos+100, theYPos+100);
        // g.drawLine(theXPos, theYPos, theXPos+30, theYPos);
        // g.drawLine(theXPos, theYPos, theXPos, theYPos+30);
        // } else {
        // g.drawLine(theXPos, theYPos, theXPos+100, theYPos-100);
        // g.drawLine(theXPos, theYPos, theXPos+30, theYPos);
        // g.drawLine(theXPos, theYPos, theXPos, theYPos-30);
        // }
        // } else {
        // if (parent.getHeight() / 2 > theYPos) {
        // g.drawLine(theXPos, theYPos, theXPos-100, theYPos+100);
        // g.drawLine(theXPos, theYPos, theXPos-30, theYPos);
        // g.drawLine(theXPos, theYPos, theXPos, theYPos+30);
        // } else {
        // g.drawLine(theXPos, theYPos, theXPos-100, theYPos-100);
        // g.drawLine(theXPos, theYPos, theXPos-30, theYPos);
        // g.drawLine(theXPos, theYPos, theXPos, theYPos-30);
        // }
        // }
    }

    public static void main(String[] args) {
        JFrame frame = new JFrame();
        frame.addWindowListener(new WindList());
        

        frame.setSize(800, 800);
        ArrowComponent ac1 = new ArrowComponent();

        frame.add(ac1);
        ac1.setArrowPosition(210, 200);
        frame.setVisible(true);
        frame.add(new PicComponent());

        Live l = new Live();
        l.theAC = ac1;
        l.xstart = 10;
        l.ystart = 10;
        l.xend = 700;
        l.yend = 700;
        l.start();
    }

}


class PicComponent extends Component {

    private int theXPos;

    private int theYPos;

    public Image img;

    private ImageIcon imgicon;

    public PicComponent() {
        setSize(800, 600);
        imgicon = new ImageIcon("/DSCF0516.JPG");
    }

    public void setArrowPosition(int x, int y) {
        setLocation(x - 100, y - 100);
        // System.out.println("insets=" + getParent().getInsets());
        // System.out.println("getParent=" + getParent());
        theXPos = x;
        theYPos = y;
    }

    public void paint(Graphics g) {
        imgicon.paintIcon(getParent(), g, -100, -100);
        
    }

    public static void main(String[] args) throws InterruptedException {
        JFrame frame = new JFrame();
        frame.addWindowListener(new WindList());

        frame.setSize(800, 800);
        ArrowComponent ac1 = new ArrowComponent();

        frame.add(ac1);
        ac1.setArrowPosition(210, 200);
        frame.setVisible(true);

        Live l = new Live();
        l.theAC = ac1;
        l.xstart = 10;
        l.ystart = 10;
        l.xend = 700;
        l.yend = 700;
        l.start();
        l = new Live();
        l.theAC = ac1;
        l.xstart = 700;
        l.ystart = 700;
        l.xend = 700;
        l.yend = 200;
        l.start();
        l.join();
        
    }

}

class Live extends Thread {
    ArrowComponent theAC;

    int xstart;

    int ystart;

    int xend;

    int yend;

    public void run() {
        int xd = xend - xstart;
        int yd = yend - ystart;
        int step = Math.max(Math.abs(xd), Math.abs(yd));
        long time = System.currentTimeMillis();
        
        while (time + step*4 > System.currentTimeMillis()) {

            int st = (int) ((System.currentTimeMillis() - time) / 4);

            SwingUtilities.invokeLater(new DrawThread(xstart + xd * st / step,
                    ystart + yd * st / step, theAC));
            try {
                sleep(20L);
            } catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }
}

class DrawThread extends Thread {
    DrawThread(int x, int y, ArrowComponent ac) {
        xx = x;
        yy = y;
        theAC = ac;
    }

    int xx;

    int yy;

    ArrowComponent theAC;

    public void run() {
        theAC.setArrowPosition(xx, yy);
        theAC.repaint();

    }
}

class WindList implements WindowListener {

    public void windowOpened(WindowEvent arg0) {
        // TODO Auto-generated method stub

    }

    public void windowClosing(WindowEvent arg0) {
        System.exit(0);

    }

    public void windowClosed(WindowEvent arg0) {
        // TODO Auto-generated method stub

    }

    public void windowIconified(WindowEvent arg0) {
        // TODO Auto-generated method stub

    }

    public void windowDeiconified(WindowEvent arg0) {
        // TODO Auto-generated method stub

    }

    public void windowActivated(WindowEvent arg0) {
        // TODO Auto-generated method stub

    }

    public void windowDeactivated(WindowEvent arg0) {
        // TODO Auto-generated method stub

    }


}
