//$Id: JTableComponent.java,v 1.1 2009/09/02 20:08:20 Administrator Exp $
package de.oltzen.awt;

import java.awt.*;
import javax.swing.*;
/**
* A JComponent with a predefinition Layout.
* <b>&copy; 1999 by Thomas Oltzen under the terms of the LGPL</b>
* @version 1.00
* @author Thomas Oltzen
*/
@SuppressWarnings("serial")
public class JTableComponent extends JComponent
{
	/** Every component has it own layout manager. */
	public TableLayout theLayout;

	/** Constructor */
	public JTableComponent(int rowcounter, int colcounter)
	{
		theLayout = new TableLayout(rowcounter,colcounter);

		setLayout(theLayout);

	}

	/** Insert a child component into the component. */
	public void insertComp ( Component comp, int row, int col)
	{
		insertComp(comp,row,col,1,1);
	}

	/** Insert a child component into the component. Additional
	* the information of the joined fields.
	*/
	public void insertComp
	(
		Component comp,
		int row,
		int col,
		int rowjoin,
		int coljoin
	)
	{
		theLayout.addComponent(comp,row,col,rowjoin,coljoin);
		add(comp);
	}

	/** Get the layout manager. */
	public TableLayout getTableLayout()
	{
		return theLayout;
	}

}