//$Id: LabelTextField.java,v 1.1 2009/09/02 20:08:20 Administrator Exp $
package de.oltzen.awt;

import javax.swing.*;
import java.awt.*;

/**
* A input field with a label.
* <b>&copy; 1999 by Thomas Oltzen, under the terms of the LGPL</b>
* @version 1.1
* @author Thomas Oltzen
*/
@SuppressWarnings("serial")
public class LabelTextField extends JComponent
{
	private JTextField theField;

	private JLabel theLabel;

	/** Create a input field. */
	public LabelTextField( String title, int label_width )
	{
		this(title, label_width, false);
	}

	/** Create a input field with password ability. */
	public LabelTextField( String title, int label_width, boolean password)
	{
		TableLayout layout = new TableLayout( 1, 2 );
		layout.setRowRel(0, 100);
		layout.setColRel(1, 100);
		layout.setColWidth(0, label_width);
		layout.setColWidth(1, 30);
		setLayout(layout);
		if (password)
		{
			theField = new JPasswordField() ;
		}
		else
		{
			theField = new JTextField();
		}
        setFocusable(false);
        theField.setFocusable(true);
		//theField.addDocumentListener(doc_listener);
		add(theField);
		layout.addComponent(theField,0,1);
		theLabel = new JLabel(title);
		add(theLabel);
		layout.addComponent(theLabel,0,0);

	}

	/** Get the text field component. */
	public JTextField getJTextField()
	{
		return theField;
	}

	/** Set the color of pen. */
	public void setLabelPenColor(Color c)
	{
		theLabel.setForeground(c);
	}

	/** Get the JLabel which contain the input field name. */
	public JLabel getJLabel()
	{
		return theLabel;
	}

	/** Get the text from the text field. */
	public String getText()
	{
		 return theField.getText();
	}

	/** Set the text into the text field. */
	public void setText(String val)
	{
		 theField.setText(val);
	}
	
    public void grabFocus()
    {
        //super.grabFocus();
        //System.out.println("request="+theField.requestFocusInWindow());
        theField.grabFocus();

    }
}