/* (C) Thomas Oltzen
 * Created on 11.01.2004
 *
 */
package de.oltzen.awt;

import javax.swing.*;

/**
 * @author Thomas Oltzen
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class MenuTableFrame extends JFrame 
{
	/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 1L;

    MethodActionPerformer theMAPerfomer;

	JMenuBar theJMenuBar;

	JMenu theCurrentJMenu;
	
	/** Constructor. */
	public MenuTableFrame()
	{
		theMAPerfomer = new MethodActionPerformer(this);
		theJMenuBar=new JMenuBar();
		setJMenuBar(theJMenuBar);
	}
	
	/** Create a menu with given title. */
	public void createMenu(String title)
	{
		theCurrentJMenu = new JMenu(title);
		theJMenuBar.add(theCurrentJMenu);
	}

	/** Create a new menu item under the last created menu. 
	 * The inherented class must ontain a menthodname without a parameter.
	 * If a user select this menu item, then call it this method.
	 * 
	 * @param title
	 * @param methodname
	 * @return
	 */
	public JMenuItem createMenuItem(String title, String methodname)
	{
		JMenuItem mi=new JMenuItem(title);
		theCurrentJMenu.add(mi);
		mi.addActionListener(theMAPerfomer);
		theMAPerfomer.watch(mi, methodname);
		return mi;
	}

	/** Create a button. The button will be add to the frame. 
	 * 
	 * @param title
	 * @param methodname
	 * @return
	 */
	public JButton createButton(String title, String methodname)
	{
		JButton button=new JButton(title);
		button.addActionListener(theMAPerfomer);
		theMAPerfomer.watch(button, methodname);
		return button;
	}

	/** Create a radio button. 
	 * 
	 * @param title
	 * @param methodname
	 * @return
	 */
	public JRadioButtonMenuItem createRadioButtonMenuItem(String title, String methodname)
	{
		JRadioButtonMenuItem mi=new JRadioButtonMenuItem(title);
		theCurrentJMenu.add(mi);
		mi.addActionListener(theMAPerfomer);
		theMAPerfomer.watch(mi, methodname);
		return mi;
	}

	/** Create a new check box menu item under the last created menu. 
	 * The inherented class must ontain a menthodname without a parameter.
	 * If a user select this menu item, then call it this method.
	 * 
	 * @param title
	 * @param methodname
	 * @return
	 */
	public JCheckBoxMenuItem createCheckBoxMenuMenuItem(String title, String methodname)
	{
		JCheckBoxMenuItem mi=new JCheckBoxMenuItem(title);
		theCurrentJMenu.add(mi);
		mi.addActionListener(theMAPerfomer);
		theMAPerfomer.watch(mi, methodname);
		return mi;
	}

	/** Get the last created menu.
	 * 
	 * @return
	 */
	public JMenu getCurrentJMenu()
	{
		return theCurrentJMenu;
	}

	/** Get the menu bar. 
	 * 
	 */
	public JMenuBar getJMenuBar()
	{
		return theJMenuBar;
	}


}
