//$Id: ProgressDialog.java,v 1.1 2009/09/02 20:08:20 Administrator Exp $
package de.oltzen.awt;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

@SuppressWarnings("serial")
public class ProgressDialog extends JDialog implements ProgressAdvance, ActionListener
{
	protected JProgressBar theProgress;
	protected JProgressBar theProgress2nd;
	protected JLabel theLabel, theLabel2nd;

	protected JButton theAbortButton;

	protected JPanel theJPanel;

	protected long theTimestamp;
	protected long theTimestamp2nd;

	protected TableLayout theLayout;

	private boolean theAbortFlag;
	
	public ProgressDialog (JFrame frame, ProgressFunction pf, Object event_obj)
	{
		this(frame, pf, event_obj, false);
	}

	public ProgressDialog (JFrame frame, ProgressFunction pf, Object event_obj, boolean has_abort)
	{
		super(frame, true);
		setSize(400,200);
		theLayout = new TableLayout(7,1);
		theLayout.setColLine(0,20);
		theLayout.setColLine(1,20);
		theLayout.setColRel(0,100);
		theLayout.setRowLine(0,10);
		theLayout.setRowLine(2,10);
		//theLayout.setRowLine(4,10);
		theLayout.setRowRel(5,100);
		theLayout.setRowHeight(5,5);
		theLayout.setRowLine(7,10);

		getContentPane().setLayout(theLayout);

		theProgress = new JProgressBar(0, 100);
		theProgress.setStringPainted(true);
		theProgress2nd = new JProgressBar(0, 100);
		theProgress2nd.setStringPainted(true);
		theLabel = new JLabel();
		theLabel2nd = new JLabel();
		theAbortButton = new JButton("Abbruch");
		//theAbortButton.setBounds(50,3,3,50);
		theAbortButton.addActionListener(this);

		insertComp(theLabel, 0,0);
		insertComp(theProgress, 1,0);
		insertComp(theLabel2nd, 2,0);
		insertComp(theProgress2nd, 3,0);
		if (has_abort){
			insertComp(theAbortButton,6,0);
		}

		MyThread my = new MyThread();
		my.theProgressDialog = this;
		my.theProgressFunction = pf;
		my.theEventObject = event_obj;
		my.start();
        setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

        setVisible(true);
        toFront();
 	}

	void insertComp ( Component comp, int row, int col)
	{
		insertComp(comp,row,col,1,1);
	}

	void insertComp
	(
		Component comp,
		int row,
		int col,
		int rowjoin,
		int coljoin
	)
	{
		theLayout.addComponent(comp,row,col,rowjoin,coljoin);
		getContentPane().add(comp);
	}

	public void invokeCreation()
	{
	}

	final public void advance(String s, int i)
    {
        try
        {
        	//for (int id = 0 ; id < 100000 ; id++) {double g = Math.sin(1.4);} ;
			if (new java.util.Date().getTime() - theTimestamp >500 ||
			    !theLabel.getText().equals(s))
			{
				theTimestamp  = new java.util.Date().getTime();
            	SwingUtilities.invokeAndWait
            		(new Runni(s, i, theLabel, theProgress));
				//SwingUtilities.invokeLater(new Runni(s, i, theProgress));
            	//Thread.yield();
			}
        }
        catch(Exception exception)
        {
            ThrowInformer.inform(exception);
        }
    }

	final public void advance2nd(String s, int i)
    {
        try
        {
			if (new java.util.Date().getTime() - theTimestamp2nd >500||
			    !theLabel.getText().equals(s))
			{
        		//for (int id = 0 ; id < 1000000 ; id++) {double g = Math.sin(1.4);} ;
				theTimestamp2nd  = new java.util.Date().getTime();
            	SwingUtilities.invokeAndWait
            		(new Runni(s, i, theLabel2nd, theProgress2nd));
				//SwingUtilities.invokeLater(new Runni(s, i, theProgress));
            	//Thread.yield();
			}
        }
        catch(Exception exception)
        {
            ThrowInformer.inform(exception);
        }
    }

	class Runni implements Runnable
	{
		String theInfo;
		JProgressBar theProgressBar;
		JLabel theInfoLabel;
		int thePerCent;

    	public void run()
    	{
       		theProgressBar.setValue(thePerCent);
        	theProgressBar.setString(""+thePerCent+"%");
        	theInfoLabel.setText(theInfo);
    	}

    	Runni(String s, int i, JLabel label, JProgressBar p)
    	{
       		theInfo = s;
	   		thePerCent = i;
	   		theProgressBar = p;
	   		theInfoLabel = label;
    	}
	}

	class MyThread extends Thread
	{

		ProgressDialog theProgressDialog;

		ProgressFunction theProgressFunction;

		Object theEventObject;

		public void run()
		{
			theProgressFunction.performProgress(theProgressDialog, theEventObject);
			//theProgressDialog.theDisposeFlag = true;
			theProgressDialog.dispose();
		}
	}

	/* (non-Javadoc)
	 * @see de.oltzen.awt.ProgressAdvance#isAbort()
	 */
	public boolean isAbort() {
		return theAbortFlag;
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent arg0) {
		theAbortFlag = true;
		theAbortButton.setEnabled(false);
	}
}

