package de.oltzen.awt;

import java.awt.*;
import javax.swing.*;

@SuppressWarnings("serial")
public class ProgressFrame extends JFrame implements ProgressAdvance
{
	protected JProgressBar theProgress;
	protected JProgressBar theProgress2nd;
	protected JLabel theLabel, theLabel2nd;
	
	protected JButton theAbortButton;

	protected JPanel theJPanel;

	protected long theTimestamp;

	protected long theTimestamp2nd;

	protected TableLayout theLayout;

	private MyThread theMyThread;
	
	private boolean theAbortFlag;

	public ProgressFrame (ProgressFunction pf, Object event_obj)
	{
		this(pf, event_obj, false);
	}
	public ProgressFrame (ProgressFunction pf, Object event_obj, boolean has_abort)
	{
		setSize(400,200);
		theLayout = new TableLayout(5,1);
		theLayout.setColLine(0,20);
		theLayout.setColLine(1,20);
		theLayout.setColRel(0,100);
		theLayout.setRowLine(0,10);
		theLayout.setRowLine(2,10);
		theLayout.setRowLine(4,10);

		getContentPane().setLayout(theLayout);

		theProgress = new JProgressBar(0, 100);
		theProgress.setStringPainted(true);
		theProgress2nd = new JProgressBar(0, 100);
		theProgress2nd.setStringPainted(true);
		theLabel = new JLabel();
		theLabel2nd = new JLabel();
		theAbortButton = new JButton("Abbruch");

		insertComp(theLabel, 0,0);
		insertComp(theProgress, 1,0);
		insertComp(theLabel2nd, 2,0);
		insertComp(theProgress2nd, 3,0);
		if (has_abort){
			insertComp(theAbortButton,4,0);
		}
		
		theMyThread = new MyThread();
		theMyThread.theProgressFrame = this;
		theMyThread.theProgressFunction = pf;
		theMyThread.theEventObject = event_obj;
	}

	public void start()
	{
		theMyThread.start();
        setVisible(true);
		toFront();
	}

	void insertComp ( Component comp, int row, int col)
	{
		insertComp(comp,row,col,1,1);
	}

	void insertComp
	(
		Component comp,
		int row,
		int col,
		int rowjoin,
		int coljoin
	)
	{
		theLayout.addComponent(comp,row,col,rowjoin,coljoin);
		getContentPane().add(comp);
	}

	public void invokeCreation()
	{
	}

	final public void advance(String s, int i)
    {
        try
        {
			if (new java.util.Date().getTime() - theTimestamp >500||
			    !theLabel.getText().equals(s))
			{
				theTimestamp  = new java.util.Date().getTime();
            	//SwingUtilities.invokeAndWait
            	//	(new Runni(s, i, theLabel, theProgress));
				SwingUtilities.invokeLater(new Runni(s, i, theLabel, theProgress));
            	Thread.yield();
			}
        }
        catch(Exception exception)
        {
            ThrowInformer.inform(exception);
        }
    }

	final public void advance2nd(String s, int i)
    {
        try
        {
			if (new java.util.Date().getTime() - theTimestamp2nd >500||
			    !theLabel.getText().equals(s))
			{
				theTimestamp2nd  = new java.util.Date().getTime();
            	//SwingUtilities.invokeAndWait
            	//	(new Runni(s, i, theLabel2nd, theProgress2nd));
				SwingUtilities.invokeLater(new Runni(s, i, theLabel2nd, theProgress2nd));
            	Thread.yield();
			}
        }
        catch(Exception exception)
        {
            ThrowInformer.inform(exception);
        }
    }

	class Runni implements Runnable
	{
		String theInfo;
		JProgressBar theProgressBar;
		JLabel theInfoLabel;
		int thePerCent;

    	public void run()
    	{
       		theProgressBar.setValue(thePerCent);
        	theProgressBar.setString(""+thePerCent+"%");
        	theInfoLabel.setText(theInfo);
    	}

    	Runni(String s, int i, JLabel label, JProgressBar p)
    	{
       		theInfo = s;
	   		thePerCent = i;
	   		theProgressBar = p;
	   		theInfoLabel = label;
    	}
	}

	class MyThread extends Thread
	{

		ProgressFrame theProgressFrame;

		ProgressFunction theProgressFunction;

		Object theEventObject;

		public void run()
		{
			theProgressFunction.performProgress(theProgressFrame, theEventObject);
			theProgressFrame.dispose();
		}
	}

	/* (non-Javadoc)
	 * @see de.oltzen.awt.ProgressAdvance#isAbort()
	 */
	public boolean isAbort() {
		return theAbortFlag;
	}
}

