/* (c) by Thomas Oltzen
 * Created on 20.03.2005
 *
 */
package de.oltzen.awt;

import java.awt.Component;

import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JProgressBar;
import javax.swing.JRadioButton;

/**
 * @author Thomas
 * 
 */
public class TomDialog extends JDialog {
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 1L;

    protected TableLayout theLayout;

    protected JFrame theFrame;
   
    private MethodActionPerformer theMAPerfomer;

    public TomDialog(JFrame frame, String title, int row, int col) throws Exception {
        super(frame);
        theFrame = frame;
        theLayout = new TableLayout(row, col);
        getContentPane().setLayout(theLayout);

        setTitle(title);
        theMAPerfomer = new MethodActionPerformer(this);
        
 
    }

    protected void insertComp(Component comp, int row, int col) {
        insertComp(comp, row, col, 1, 1);
    }

    protected void insertComp(Component comp, int row, int col, int rowjoin, int coljoin) {
        theLayout.addComponent(comp, row, col, rowjoin, coljoin);
        getContentPane().add(comp);
    }

    /** Create a button. The button will be add to the frame.
    *
    * @param title
    * @param methodname
    * @return
    */
   public JButton createButton(String title, String methodname)
   {
       JButton button=new JButton(title);
       button.addActionListener(theMAPerfomer);
       theMAPerfomer.watch(button, methodname);
       if (!theMAPerfomer.hasMessageFlag()){
           button.setEnabled(false);
       }
       return button;
   }

   /** Create a button. The button will be add to the frame.
    *
    * @param title
    * @param methodname
    * @return
    */
   public JButton createButton(Icon icon, String methodname)
   {
       JButton button=new JButton(icon);
       button.addActionListener(theMAPerfomer);
       theMAPerfomer.watch(button, methodname);
       if (!theMAPerfomer.hasMessageFlag()){
           button.setEnabled(false);
       }
       return button;
   }

   /** Create a radio button. The button will be add to the frame.
    *
    * @param title
    * @param methodname
    * @return
    */
   public JRadioButton createRadioButton(String title, String methodname)
   {
       JRadioButton button=new JRadioButton(title);
       button.addActionListener(theMAPerfomer);
       theMAPerfomer.watch(button, methodname);
       if (!theMAPerfomer.hasMessageFlag()){
           button.setEnabled(false);
       }
       return button;
   }

}