//$Id: FwComponent.java,v 1.1 2009/09/02 20:08:21 Administrator Exp $
package de.oltzen.fw.tree;

import javax.swing.JComponent;

/** This listerner is usual implements by a JComponent. <br>
* Sorry, the comments are in german. I hope I have time for a good
* documentation.<br>
* <b>&copy; 1999 by Thomas Oltzen, under the terms of the LGPL</b>
* @version 1.0
* @author Thomas Oltzen
*/

public interface FwComponent
{

    /** Das Frame informiert dem Interface, da es angezeigt wird. In der Regel
	* werden die Menaktionen, Fenstertitel usw. erstellt. Fr eine gute Performance
	* ist es auch denkbar, da beim ersten Aufruf die internen Komponenten ( z.B.
	* Eingabefeder ) erstellt werden.
	* <pre>
	*       frame.setAction("Copy", this, "copyStringToClipbord");
	*
	*       public void copyStringToClipbord () { ...
	* </pre>
    */
    void viewOnFrameAction (FwTreeFrame frame);

  	/** Wird von Frame aufgerufen, wenn die Komponente aus dem rechten Bereich
	* verschwindet.
	*/
	void disappearFromFrame ();

	/** Liefert die JComponent. Diese Komponente zeigt das Frame an.
	* Usually is this <code>this</code>
	*/
	JComponent getFrameComponent ();

	/** Get the entry name for the tree. */
	String getTreeBranchName ();

}