//$Id: ReadUtil.java,v 1.1 2009/09/02 20:08:22 Administrator Exp $
package de.oltzen.io;

import java.io.*;

import javax.swing.JProgressBar;

import de.oltzen.awt.*;

public class ReadUtil
{
	/** Read the InputStream and store into the buffer. The reading is
	* blocking until not read all bytes. */
	public static void readFully(InputStream is, byte[] buffer)
	throws IOException
	{
		int offset = 0;
		while (offset < buffer.length)
		{
			int count = is.read(buffer, offset, buffer.length-offset);
			if (count == -1)
			{
				throw new IOException("Read not all bytes from stream.");
			}
			offset = offset + count;
		}
	}

	/** Read the InputStream and store into the buffer. The reading is
	* blocking until not read all bytes. */
	public static void readFully
	(
		InputStream is,
		byte[] buffer,
		ProgressAdvance pa,
		String title
	)
	throws IOException
	{
		int offset = 0;
		while (offset < buffer.length)
		{
			pa.advance(title, offset * 100 / buffer.length);
			int steplength = buffer.length-offset;
			int count = is.read(buffer, offset, steplength>8096 ? 8096 : steplength);
			if (count == -1)
			{
				throw new IOException("Read not all bytes from stream.");
			}
			offset = offset + count;
		}
	}

    /** Read the InputStream and store into the buffer. The reading is
    * blocking until not read all bytes. */
    public static void readFully
    (
        InputStream is,
        byte[] buffer,
        JProgressBar pa
    )
    throws IOException
    {
        int offset = 0;
        while (offset < buffer.length){
            pa.setValue( offset * 100 / buffer.length);
            int steplength = buffer.length-offset;
            int count = is.read(buffer, offset, steplength>8096 ? 8096 : steplength);
            if (count == -1){
                throw new IOException("Read not all bytes from stream.");
            }
            offset = offset + count;
        }
    }

	public static byte[] readFully(InputStream is)
	throws IOException
	{
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		byte [] buffer = new byte[100000];
		int readlen = 0;
		while (readlen >= 0)
		{
			readlen = is.read(buffer,0, 100000);
			if (readlen > 0)
			{
				baos.write(buffer, 0, readlen);
			}
		}
		baos.close();
		return baos.toByteArray();
	}

}