/* (c) by Thomas Oltzen
 * Created on 02.10.2011
 *
 */
package de.oltzen.pianoteacher;

import java.awt.FileDialog;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;

import ch.ntb.usb.Device;
import ch.ntb.usb.LibusbJava;
import ch.ntb.usb.USB;
import ch.ntb.usb.Usb_Bus;
import ch.ntb.usb.Utils;

import de.oltzen.awt.TomFrame;

public class PTFrame extends TomFrame{
    
    
    public PTFrame(){
        super(1,1);
        setTitle("MIDI Loader");
        this.insertComp(createButton("load", "doLoad"), 0, 0);
        this.setSize(100,100);
    }
    
    public static void main(String[] args)
    {
        new PTFrame().setVisible(true);
    }
    
    public void doLoad() throws Exception{
        FileDialog fd = new FileDialog(this, "Select MIDI File.", FileDialog.LOAD);
        fd.setVisible(true);
        System.out.println("filename="+fd.getFile());
        System.out.println("filename="+fd.getDirectory());
        String fname = fd.getDirectory()+"/"+fd.getFile();
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        new MidiConverter().convert(new FileInputStream(fname), baos);
        baos.close();
        FileOutputStream fo = new FileOutputStream(fname+".dll");
        new MidiConverter().convert(new FileInputStream(fname), fo);
        fo.close();
        byte[] buffer = baos.toByteArray(); 
       // if (true) return;
        int badr =0 ;
        logBus();
        Device dev = USB.getDevice((short) 0x16c0, (short) 0x5dc);
        dev.open(1, 0, -1);
        while (badr<buffer.length){
            int blen =1024;
            if (buffer.length <badr+blen){
                blen = buffer.length-badr;
            }
            byte[] send_buffer = new byte[blen];
            System.arraycopy(buffer, badr, send_buffer, 0, blen);
            dev.controlMsg(USB.REQ_TYPE_TYPE_VENDOR | USB.REQ_TYPE_RECIP_DEVICE , 1,
                    2, badr, send_buffer, blen, 100000, true);
            badr+=blen;
        }
        dev.close();
        
        
    }
    
    private static void logBus()
    {
        // if you don't use the ch.ntb.usb.Device class you must initialise
        // Libusb before use
        LibusbJava.usb_init();
        LibusbJava.usb_find_busses();
        LibusbJava.usb_find_devices();

        // retrieve a object tree representing the bus with its devices and
        // descriptors
        Usb_Bus bus = LibusbJava.usb_get_busses();

        // log the bus structure to standard out
        Utils.logBus(bus);
    }

}
