//$Id: BoolArray.java,v 1.1 2009/09/02 20:08:22 Administrator Exp $
package de.oltzen.util;

import java.io.*;

public class BoolArray implements Serializable
{
    private static final long serialVersionUID = 5026195207621870227L;

    private int theSize;

	private boolean[] theArray;

	public BoolArray ()
	{
		theArray = new boolean[0];
	}
    
    public BoolArray (int ensure)
    {
        theArray = new boolean[ensure];
    }


	public BoolArray (boolean[] array)
	{
		theArray = array;
		theSize = array.length;
	}

	/** Ensure that the internal array has a suitable length. The perfomance
	* of the <code>put</code> method can be accelarating.
	*/
	public void ensure (int max_index)
	{
		if (theArray.length <= max_index)
		{
			boolean[] newarray = new boolean[max_index+1];
			System.arraycopy(theArray, 0, newarray, 0 , theArray.length);
			theArray = newarray;
		}
	}

	public boolean get (int index)
	{
		return theArray.length <= index ? false : theArray[index];
	}

	public void put (int index, boolean value)
	{
		if (theArray.length <= index)
		{
		    int new_len = index+1;
            if (new_len < theArray.length*2/3) new_len = theArray.length*2/3;
            boolean[] newarray = new boolean[new_len];
            System.arraycopy(theArray, 0, newarray, 0 , theArray.length);
			theArray = newarray;
		}
		if (index+1 > theSize) theSize= index+1;
		theArray[index] = value;
	}

	public void add (boolean value)
	{
		put(theSize, value);
	}

	public void setSize(int size)
	{
		if (theSize > size)
		{
			theSize = size;
		}
		else
		{
			put(size, false);
		}
	}

	public int size()
	{
		return theSize;
	}

    /** Return the internal array size. */
    public int getEnsureSize()
    {
        return theArray.length;
    }

    /** Return the position in the array. If result -1, then is the number not
	* in the array.
	*/
	public boolean[] getArray()
	{
		boolean[] newarray = new boolean[theSize];
		System.arraycopy(theArray, 0, newarray, 0 , theSize);
		return newarray;
	}
}