//$Id: ShortArray.java,v 1.1 2009/09/02 20:08:22 Administrator Exp $
package de.oltzen.util;

import java.io.Serializable;

public class ShortArray implements Serializable
{

	/**
     * 
     */
    private static final long serialVersionUID = 322023228120271255L;

    private int theSize;

	private short[] theArray;

	public ShortArray ()
	{
		theArray = new short[0];
	}

    public ShortArray (int ensure)
    {
        theArray = new short[ensure];
    }


    public ShortArray (short[] array)
	{
		theArray = array;
	}

	public short get (int index)
	{
		return theArray[index];
	}

	public void put (int index, short value)
	{
		if (theArray.length <= index)
		{
		    int new_len = index+1;
            if (new_len < theArray.length*2/3) new_len = theArray.length*2/3;
            short[] newarray = new short[new_len];
            System.arraycopy(theArray, 0, newarray, 0 , theArray.length);
			theArray = newarray;
		}
		theArray[index] = value;
	}

    /** Ensure that the internal array has a suitable length. The perfomance
    * of the <code>put</code> method can be accelarating.
    */
    public void ensure (int max_index)
    {
        if (theArray.length <= max_index)
        {
            short[] newarray = new short[max_index+1];
            System.arraycopy(theArray, 0, newarray, 0 , theArray.length);
            theArray = newarray;
        }
    }

    public void setSize(int size)
	{
		if (theSize > size)
		{
			theSize = size;
		}
		else
		{
			put(size, (short)0);
		}
	}

	public int size()
	{
		return theArray.length;
	}

    /** Return the internal array size. */
    public int getEnsureSize()
    {
        return theArray.length;
    }

    public short[] getArray()
	{
		short[] newarray = new short[theArray.length];
		System.arraycopy(theArray, 0, newarray, 0 , theArray.length);
		return newarray;
	}

}