//$Id: UndoListManager.java,v 1.1 2009/09/02 20:08:22 Administrator Exp $
package de.oltzen.util;

import java.util.*;

public class UndoListManager
{
	private List theData;

	private Vector theRedoList;

	private int theStepNo;

	private int theMaxStepNo;

	public UndoListManager(List startdata)
	{
		theRedoList = new Vector();
		Vector list = new Vector();
		int len = startdata.size();
		for (int i = 0 ; i < len ; i++) list.add(startdata.get(i));
		List outdata = list;
		theRedoList.add(new RedoNewListAction(outdata));
		theData = startdata;
	}

	public List getActualList()
	{
		return theData;
	}

	private RedoListAction getAction(int step)
	{
		return (RedoListAction) theRedoList.get(step);
	}

	public void addAction(RedoListAction redo)
	{
		if (redo.isNewList())
			theData = redo.action(null);
		theStepNo++;
		if (theRedoList.size()<=theStepNo){
			theRedoList.add(redo);
		} else {
			theRedoList.set(theStepNo, redo);
		}
		theMaxStepNo = theStepNo;
	}

	public List redo()
	{
		if (theStepNo == 0) theStepNo = 1;
		if (theStepNo <= theMaxStepNo){
			Vector list = new Vector();
			int len = theData.size();
			for (int i = 0 ; i < len ; i++) list.add(theData.get(i));
			theData = getAction(theStepNo).action(list);
			theStepNo++;
		}
		return theData;
	}

	public List undo()
	{
		if (theStepNo == 0) return theData;
		theStepNo--;
		int basisstep = theStepNo;
		while (basisstep >= 0 && !getAction(basisstep).isNewList()){
			basisstep--;
		}
		List data = getAction(basisstep).action(null);
		Vector list = new Vector();
		int len = data.size();
		for (int i = 0 ; i < len ; i++) list.add(data.get(i));
		List outdata = list;
		for (int i = basisstep+1; i <= theStepNo ; i++){
			//System.out.println("i="+ i+ " "+getAction(i));
			outdata = getAction(i).action(outdata);
		}
		theData = outdata;
		return outdata;
	}
}
